--NOTES:
--Won`t work with some semo VSTs that wont load presets Glue etc.
--Make sure compressor 100% stereo linked


--add send devices to all tracks (bar kick)
--link fx on send tracks

local menu_call = false --flag that menu is calling and requires 4X4 beat to be set up on track

--Renoise Keybinds and menus
-------------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:Set Up Fake Sidechain",
  invoke = function()set_up_send_devices_all_tracks()end  
}

renoise.tool():add_keybinding {
  name = "Global:Tools:Sync Fake Sidechain Sends",
  invoke = function()main_gui()end  
}

-------------------------------------------------------------
--Menus
-------------------------------------------------------------
renoise.tool():add_menu_entry {
  name = "Instrument Box:Set Up As Fake Sidechain Source and Kick Track",
  invoke = function() menu_call = true --menu_call flag means that a kick track is set up automatically
                      set_up_send_devices_all_tracks()
                      menu_call = false
                      main_gui()
                      end
}

renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:Sync Fake Sidechain Sends",
  invoke = function()main_gui()end  
}

--------------------------------------------------------------------------------
--some basic colors for gui elements
--------------------------------------------------------------------------------
--e.g. For changing vb.views["sample present colour 2"].color when states change
COLOR_GREY = {0x30,0x42,0x42}
COLOR_ORANGE ={0xFF,0x66,0x00}
COLOR_YELLOW = {0xE0,0xE0,0x00}
COLOR_BLUE = {0x50,0x40,0xE0}  
COLOR_RED = {0xEE,0x10,0x10}
COLOR_GREEN = {0x20,0x99,0x20}

--Constants holding first index of color-code: Used to identify color in vb.views table i.e.
--if vb.views["button"].color[1] == COLOR_ORANGE_FLAG then --etc
COLOR_GREY_FLAG = 0x30
COLOR_ORANGE_FLAG = 0xFF
COLOR_YELLOW_FLAG = 0xE0
COLOR_BLUE_FLAG = 0x50  
COLOR_RED_FLAG = 0xEE
COLOR_GREEN_FLAG = 0x20
--------------------------------------------------------------------------------

COMPRESSOR_ACTIVE_PRESET_DATA =
[[<?xml version="1.0" encoding="UTF-8"?>
<FilterDevicePreset doc_version="11">
  <DeviceSlot type="CompressorDevice">
    <IsMaximized>true</IsMaximized>
    <LogThreshold>
      <Value>10.8380318</Value>
    </LogThreshold>
    <Ratio>
      <Value>16</Value>
    </Ratio>
    <Attack>
      <Value>2.76072431</Value>
    </Attack>
    <Release>
      <Value>40.7708054</Value>
    </Release>
    <Gain>
      <Value>3.18853736</Value>
    </Gain>
  </DeviceSlot>
</FilterDevicePreset>]]

--Globals
local sc_src = false
local sc_send_left = false
local sc_send_right = false

local g_device_count = 0
local g_button_count = 0

local MASTER_TRACK = 1
local LUA_COUNTS_FROM_1 = 1
--loadable devices start at 2,
--renoise mixer device is 1
local FIRST_DEVICE_INDEX = 2
local MIXER_DEVICE = 1

--global
g_link_parameters_table = {}

local my_dialog = nil 
local my_dialog2 = nil
--for viewbuilder
local vb = nil
local vb2 = nil

--declare empty function to deal with upvalue calls
--it will be re-assigned later (like prototyping)
local timer = function()end




--------------------------------------------------------------------------------
--helper function : custom status message --prefixes tool name and adds brackets 
--------------------------------------------------------------------------------
local function status(message)
  renoise.app():show_status("Sidechain Tool: ("..message..")")
end

--takes a string parameter of the device display name and
--returns the portion of the string after the second colon 
--i.e. "VST:Plug Company:Super Compressor" --> returns "Super Compressor"
-------------------------------------------------------
local function truncate_plugin_device_name(device_name)
-------------------------------------------------------
  local MAX_LENGTH = 20
  local last_colon = string.find(device_name, ":")
  --check if colon present
  last_colon = string.find(device_name, ":")
  --if no colons then just return the sting unaltered
  if last_colon == nil then
    --truncate to 20 chars
    if #device_name > MAX_LENGTH then
      return string.sub(device_name,-MAX_LENGTH)
    else
      return device_name
    end 
  else
    --strip out `VST:`
    device_name = string.sub(device_name, (last_colon + 1))
    --find second colon
    last_colon = string.find(device_name, ":")
    --strip out `manufacturer name:` and return plug name
    device_name = string.sub(device_name, (last_colon + 1)) 
    --truncate to 20 chars
    if #device_name > MAX_LENGTH then
      return string.sub(device_name,-MAX_LENGTH)--truncate to 100 chars
    else
      return device_name
    end 
  end
end

--returns the indexes and send number (from S1 == 1) or nil values
----------------------------------------------
local function get_sc_send_indexes()
----------------------------------------------  
  local indexes = {}
  indexes.track ={}
  indexes.send_no = {}
  --get both track indexes and send target indexes used in send devices
  indexes.track[1] = nil
  indexes.track[2] = nil
  indexes.send_no[1] = nil
  indexes.send_no[2] = nil
  
  local song = renoise.song()
  local counter = 1
  local first_send = song.sequencer_track_count + MASTER_TRACK + 1
  --loop to find what number send is
  for track = first_send, #song.tracks do
    if song:track(track).name == "SC Left" then
      indexes.track[1] = track
      indexes.send_no[1] = counter
    end
    if song:track(track).name == "SC Right" then
      indexes.track[2] = track
      indexes.send_no[2] = counter
    end
    --increment counter
    counter = counter + 1
  end 
  
  --return the two indexes
  return indexes 
  
end--fn
 --------------------------------------------- 

---HAVE TO BE SUPER CAREFUL WITH STRING FORMATS HERE (copy pasting format wrong can cause errors)****


local function get_search_strings_for_send_device_routings()
  local routings ={}
  local send_indexes = get_sc_send_indexes()
  send_indexes.send_no[1] = send_indexes.send_no[1] - LUA_COUNTS_FROM_1
  send_indexes.send_no[2] = send_indexes.send_no[2] - LUA_COUNTS_FROM_1

  local send_pointing_to_none_string =   
    [[<DestSendTrack>
      <Value>-1</Value>
    </DestSendTrack>]]

  local send_pointing_to_left_string =
    [[<DestSendTrack>
      <Value>]]..send_indexes.send_no[1]..".0"..[[</Value>
    </DestSendTrack>]]

  local send_pointing_to_right_string =
    [[<DestSendTrack>
      <Value>]]..send_indexes.send_no[2]..".0"..[[</Value>
    </DestSendTrack>]]

   routings.none = send_pointing_to_none_string
   routings.left = send_pointing_to_left_string
   routings.right = send_pointing_to_right_string
   return routings
end 

--called by button notifier
-------------------------------------
--makes sure both the left and right sc sends have synced
--devices, if not it clears right hand send and copys left devices to it
-------------------------------------
local function sync_track_devices(template_track_index , target_track_index)
  
  --loadable devices start at 2,
  --renoise mixer device is 1
  local FIRST_DEVICE_INDEX = 2
  --song object
  local song = renoise.song()
 -- local send_indexes = get_sc_send_indexes()
  --track objects
  local template_track = song:track(template_track_index)
  local target_track = song:track(target_track_index)
  
  --flag to set whether devices need refreshing/ reordering/ reoloading
  local refresh_devices = false
  
  --1) make sure number of devices in each send chain matches up, set flag if not
  if #template_track.devices ~= #target_track.devices then
    refresh_devices = true
  end
  
  --2) Check the order, that device types/names match up (skip this loop if flag already triggered to true)
  if refresh_devices == false then
    --loop devices 
    for i = FIRST_DEVICE_INDEX, #template_track.devices do
      --make sure presets are already matched
      if template_track:device(i).name ~= target_track:device(i).name then
        refresh_devices = true
        break
      end 
    end
  end
  
  --3) match all active/bypassed states, done by default rather than triggering final loop
  if refresh_devices == false then
    for i = FIRST_DEVICE_INDEX,#template_track.devices do
      if target_track:device(i).is_active ~= template_track:device(i).is_active then
        target_track:device(i).is_active = template_track:device(i).is_active
      end
    end
  end
  
  --4) return if flag not tripped, else reload/ copy template track devices to target track
  if refresh_devices == false then
    return
  else
    --loop backwards through target devices and delete them
    for i = #target_track.devices,FIRST_DEVICE_INDEX,-1 do
      target_track:delete_device_at(i)
    end

    
    --copy fx from template track to target track
    for i = FIRST_DEVICE_INDEX,(#template_track.devices) do
      --copy device
      target_track:insert_device_at(template_track:device(i).device_path, i)
      --copy preset data
      target_track:device(i).active_preset_data = template_track:device(i).active_preset_data
      --copy enabled state
      target_track:device(i).is_active = template_track:device(i).is_active
    end
     
    --update device count (custom to tool)
    g_device_count = #template_track.devices -1
    ----------------------------
   
   
    --set panning for right and left tracks
      --.postfx_panning.value = 0
     -- right_send_track.postfx_panning.value = 1

  end
end--sync_track_devices()


--restart tool gui to update 
-----------------------------
local function restart_tool()
------------------------------
  renoise.tool():remove_timer(timer)
 -- ("timer_removed")
  if my_dialog ~= nil then
    my_dialog:close()
    my_dialog = nil
  end
  --restart tool
  main_gui()
  return
end


--add send (right SC)
-------------------------
local function add_send_pointing_to_right_sc(track,delete)
   
   local song = renoise.song()
   local send_indexes = get_sc_send_indexes()
   local send_pointing_to_right_string = get_search_strings_for_send_device_routings().right
   --[[
   
   routings.none = send_pointing_to_none_string
   routings.left = send_pointing_to_left_string
   routings.right = send_pointing_to_right_string
   
   
   --]]
   
   
   for device = #song:track(track).devices,2,-1 do
     local dev = song:track(track):device(device)
     if dev.device_path == "Audio/Effects/Native/#Send" then
       if string.find(dev.active_preset_data, send_pointing_to_right_string,1,true) ~= nil then
         song:track(track):delete_device_at(device)
        -- send_to_left_found = true
         break
       end
     end
   end
   
   if delete == true then
     return
   end
   
   --add send
   
     local target_to_string = tostring(send_indexes.send_no[2] - LUA_COUNTS_FROM_1)
     local send_device = song:track(track):insert_device_at("Audio/Effects/Native/#Send",#song:track(track).devices + 1)
   send_device.active_preset_data =
                              
         [[<?xml version="1.0" encoding="UTF-8"?>
      <FilterDevicePreset doc_version="9">
        <DeviceSlot type="SendDevice">
          <IsMaximized>true</IsMaximized>
          <SendAmount>
            <Value>1.0</Value>
          </SendAmount>
          <SendPan>
            <Value>1.0</Value>
          </SendPan>
          <DestSendTrack>
            <Value>]]..target_to_string..[[</Value>
          </DestSendTrack>
          <MuteSource>true</MuteSource>
          <SmoothParameterChanges>true</SmoothParameterChanges>
        </DeviceSlot>
      </FilterDevicePreset>
      ]]
   send_device:parameter(1).show_in_mixer = false
   send_device.display_name = "To SC Right"
   return send_device
end

--add send (left SC)
--------------------------------------------------
local function add_send_pointing_to_left_sc(track,delete)
   -- flag
   -- local send_to_left_found = false
   local song = renoise.song()
   local send_indexes = get_sc_send_indexes()
   local send_pointing_to_left_string = get_search_strings_for_send_device_routings().left
   
   for device = #song:track(track).devices,2,-1 do
     local dev = song:track(track):device(device)
     if dev.device_path == "Audio/Effects/Native/#Send" then
       if string.find(dev.active_preset_data, send_pointing_to_left_string,1,true) ~= nil then
         song:track(track):delete_device_at(device)
      
        -- send_to_left_found = true
         break
       end
     end
   end

   if delete == true then
     return
   end

   --add send
   
     local target_to_string = tostring(send_indexes.send_no[1] - LUA_COUNTS_FROM_1)
     local send_device = song:track(track):insert_device_at("Audio/Effects/Native/#Send",#song:track(track).devices + 1)
       send_device.active_preset_data =
                                  
             [[<?xml version="1.0" encoding="UTF-8"?>
          <FilterDevicePreset doc_version="9">
            <DeviceSlot type="SendDevice">
              <IsMaximized>true</IsMaximized>
              <SendAmount>
                <Value>1.0</Value>
              </SendAmount>
              <SendPan>
                <Value>0</Value>
              </SendPan>
              <DestSendTrack>
                <Value>]]..target_to_string..[[</Value>
              </DestSendTrack>
              <MuteSource>false</MuteSource>
              <SmoothParameterChanges>true</SmoothParameterChanges>
            </DeviceSlot>
          </FilterDevicePreset>
          ]]
   send_device:parameter(1).show_in_mixer = false
   send_device.display_name = "To SC Left"
   return send_device
end


--function that checks a track for sc sends and returns 1,2,3 
--for the routing gui

--NEEDS TO CHECK FOR TWO SENDS and routed properly***

local function get_tracks_state(track)
 -- local track = 2
  local song = renoise.song()
  local send_indexes = get_sc_send_indexes()
  local send_pointing_to_left_string = get_search_strings_for_send_device_routings().left
  local send_pointing_to_right_string = get_search_strings_for_send_device_routings().right
  --default is bypassed
  local routing_index = 3
  
   for device = #song:track(track).devices,2,-1 do
     local dev = song:track(track):device(device)
     --look for send devices
     if dev.device_path == "Audio/Effects/Native/#Send" then
     --  print(string.find(dev.active_preset_data, send_pointing_to_left_string,1,true))
       if string.find(dev.active_preset_data, send_pointing_to_left_string,1,true) ~= nil then
         --send is pointing to left sc send
         
         if dev:parameter(2).value == 1 then --send points to right track so source track
            
            routing_index = 1 --effected
            return 1
         end
         
         if dev:parameter(2).value == 0 then --send points to right track so source track
            routing_index = 2 --
            return 2
         end
       end
     end
   end
  
  return 3 --bypassed
end


---------------------------
local function timer1()
---------------------------
--get_tracks_state(2)

  --release timer if GUI no longer visible
  ----------------------------------------
   if my_dialog and (my_dialog.visible == false) then
      --add timer to fire once every 50ms
    if renoise.tool():has_timer(timer) then
      renoise.tool():remove_timer(timer)
     -- ("timer_removed")
      my_dialog = nil 
      return
    end
  end
  
  --song object
  -----------------
  local song = renoise.song()
  --get sidechain send (sc-send) indexes
  local send_indexes = get_sc_send_indexes()
  local left_track_index = send_indexes.track[1]
  local right_track_index = send_indexes.track[2]
  --sc-send track objects
  local left_track = song:track(left_track_index)
  local right_track = song:track(right_track_index)
 
  --3 early returns
  ---------------
  --1)return if sc-send track not found  
  if (left_track_index == nil)
  or (right_track_index == nil) then
    status("sc tracks incomplete")
    
    ----------------------------------------
    ---***TODO: GUI to Set up sc tracks*****
    -----------------------------------------
    
    return
  end
  
  --make sure a device is always selected 
  if song.selected_device == nil then
    song.selected_device_index = 1
  end
 
  --2) return if no devices present on left sc track 
  if #left_track.devices == 1 then
    --if the first button is still present but no devices are present on left track
    --then restart tool
    if vb.views["dev button"..1] ~= nil then
      restart_tool()
    end
    return
 
  end
 
  --3)return if left sc track is not the selected track in renoise and set all buttons to grey
  if song.selected_track_index ~= left_track_index then
    for i = 2, (#song:track(left_track_index).devices) do-- - 1) do
      local button_index = i-1
      if vb.views["dev button"..button_index] ~= nil then
        vb.views["dev button"..button_index].color = COLOR_GREY
      end
    end
    vb.views["minislider readout"].visible = false
    return
  end
  
  
  --We now know we are on left SC track, it is selected and it has loaded device/s
  --so get selected device in renoise
  ----------------------------------
  --default to mixer device if no device selected in renoise selected
  if song.selected_track_device_index == 0 then
    song.selected_track_device_index = 1
  end
 
  local target_device = song.selected_track_device
  --set target index for gui (colors)
  local selected_button_index = song.selected_track_device_index - 1
 

  -----------------------------------------
  local function check_device_names_match()
  -----------------------------------------
    --if number of devices doesn`t match then return false
    if #left_track.devices ~=  #right_track.devices  then
      return false
    else
      for i = 2, #left_track.devices do
        --make sure presets are already matched
        if left_track:device(i).name ~= right_track:device(i).name then
          --names don`t match so return false
          return false
        end 
      end
      --all name comparisons matched so return true
      return true
    end
  end
  --------------------------

  --restart tool if stored device count is wrong: i.e. buttons won`t match
  --if device count == 0
  if g_device_count ~= #left_track.devices - MIXER_DEVICE
  or g_device_count == 0
  or g_button_count ~= g_device_count
  or check_device_names_match() == false then-- - 1) then --check the number of buttons on the gui corresponds with the device count
    restart_tool()
  end
  

  --gui colors (the colors behave as flags in tyhe tool as well as feedback)
  -------------
  for i = 1, (#song:track(left_track_index).devices -1) do
    if i == selected_button_index then
     -- if song.selected_track_device.external_editor_available == true
     -- and song.selected_track_device.external_editor_visible == true then
        --check if device is linked
        if song.selected_track_device.parameters[1].value_observable:has_notifier(g_link_parameters_table[1]) then
          vb.views["dev button"..i].color = COLOR_GREEN
          --make sur eactive state of devices matches (not part of device preset)
          right_track:device(song.selected_track_device_index).is_active = song.selected_track_device.is_active
        else
          vb.views["dev button"..i].color = COLOR_ORANGE
        end 
     -- else
      -- vb.views["dev button"..i].color = COLOR_ORANGE
     -- end  
    else
      vb.views["dev button"..i].color = COLOR_GREY
    end
  end  
end--timer1
------------------------------------
-----------------------------------
--assign timer1 to variable timer 
timer = timer1

--SELECTED TRACK DEVICE NAMES
----------------------------------------------------------
--function returns all of a tracks device names
--used to populate buttons, pass in track index
----------------------------------------------------------
function get_all_track_device_names(track)
  
  local song = renoise.song()
  local name_table = {}
  --loop through devices to get names
  for i =  FIRST_DEVICE_INDEX,(#song:track(track).devices) do
    local device = song:track(track).devices[i] --skip custom Last FX gainer, used by tool
   -- if device.display_name ~= "Last Fx" then
      name_table[i-1] = device.display_name
   -- end
  end
  --return table of device names
  return name_table 
end

-------------------------------------------------------
--function returns the track index of the left SC send 
--used as control track for Devices when gui open
-------------------------------------------------------
function get_sc_left_track_index()
  local song = renoise.song()
  --find Left sidechain send track and get the index
  for track = #song.tracks,1,-1 do
    if song:track(track).name == "SC Left" then
      return track
    end
  end
end



---------------------
function main_gui()
---------------------
 

  --toggle dialog
  if my_dialog and (my_dialog.visible == true) then
    my_dialog:close()
    return
  end
  
  
  local song = renoise.song()
  
  --set globals
  
   --Globals
  sc_src = false
  sc_send_left = false
  sc_send_right = false
  g_device_count = 0
  -------------
  
  --------------------------------------------------
  local function add_sc_send_tracks_if_not_present()
  --------------------------------------------------
    local song = renoise.song()
    --set global flags to false
    sc_send_left = false
    sc_send_right = false
    --loop to check for send SC tracks
    for track = (song.sequencer_track_count + 1), #song.tracks do
      if song:track(track).name == "SC Left" then
        sc_send_left = track
      elseif song:track(track).name == "SC Right" then
        sc_send_right = track
      end
    end
    
    --add left send track if not present
    ------------------------------------
    if (sc_send_left == false) then
      local insert_index = (song.sequencer_track_count + MASTER_TRACK + 1)
      song:insert_track_at(insert_index)
      song:track(insert_index).name = "SC Left"
      sc_send_left = insert_index
      --insert native compressor
      local compressor = song:track(insert_index):insert_device_at("Audio/Effects/Native/Compressor",2)
      compressor.active_preset_data =COMPRESSOR_ACTIVE_PRESET_DATA
    end
    
    --add right send track if not present
    --------------------------------------
    if (sc_send_right == false) then
      local insert_index = (sc_send_left + 1)
      song:insert_track_at(insert_index)
      song:track(insert_index).name = "SC Right"
      sc_send_right = insert_index
      --insert native compressor
      local compressor = song:track(insert_index):insert_device_at("Audio/Effects/Native/Compressor",2)
      compressor.active_preset_data =COMPRESSOR_ACTIVE_PRESET_DATA
    end
  end--end local fn
  --------------------------------------------------
  --------------------------------------------------
  add_sc_send_tracks_if_not_present()
  

  
  
  
  
  
  --assign global vb to viewbuilder
  vb = renoise.ViewBuilder()
  
  if get_sc_send_indexes().track[1] == nil then
   -- status("No SC TRACKS PRESENT")
    return
  end
  g_device_count = #song:track(get_sc_left_track_index()).devices - 1
 
  local send_indexes = get_sc_send_indexes()
  local left_send_track = song:track(send_indexes.track[1])
  local right_send_track = song:track(send_indexes.track[2])
  
  --first run sync up right send track to left
  -- if Last Fx is out of place then rectify that 
  ---------------------------------
    local function refresh_devices()
  
    local song = renoise.song()
    
    
    --loop backwards through send 2`s devices and delete them
      for i = #right_send_track.devices,2,-1 do
        right_send_track:delete_device_at(i)
      end
 
      --copy fx from track 1
      for i = 2,(#left_send_track.devices) do -- - 1) do
        --copy device
        right_send_track:insert_device_at(left_send_track:device(i).device_path, i)
        --copy preset data
        right_send_track:device(i).active_preset_data = left_send_track:device(i).active_preset_data
        --copy enabled state
        right_send_track:device(i).is_active = left_send_track:device(i).is_active
      end
      
      --set panning for right and left tracks
      left_send_track.postfx_panning.value = 0
      right_send_track.postfx_panning.value = 1
    end
    -----------------
    --run
    refresh_devices()
    -----------------
  
  --gui
  -----
  local button --variable to hold first row content
  local ext_ed
  -------------------------------------------------
  local function has_external_editor(button_number)
  -------------------------------------------------
    local editor = {}
    editor.available = false
    editor.visible = COLOR_GREY
    
    if left_send_track:device(button_number + 1).external_editor_available == false then
      return editor
    else
      editor.available = true
    end
    if left_send_track:device(button_number + 1).external_editor_visible then
      editor.visible = COLOR_GREEN
    end
    return editor
  end
  
  
  local button_strip = vb:column {margin = 4}
  
  local left_track_dev_names = get_all_track_device_names(get_sc_left_track_index())--returns all minus mixer
  
 -- rprint(left_track_dev_names )
  
  --loop to add device buttons
  ----------------------------
  for i = 1,#left_track_dev_names  do
    --update global button count
    g_button_count = i
    
    button = vb:row{ 
        vb:button{
                   id = "dev button"..(i),
                   width = 150,
                   height = 40,
                   text = truncate_plugin_device_name(left_track_dev_names[i]),
                   color = COLOR_GREY,
                   notifier = function(value)
                   
                                
                                
                                local button_number = i
                                local linked_device_index = i + 1
                                
                                vb.views["minislider readout"].visible = true
                                
                                
                                --indexes
                                local send_indexes = get_sc_send_indexes()
                                local left_track_index = send_indexes.track[1]
                                local right_track_index = send_indexes.track[2]
                                --track objects
                                local song = renoise.song()
                                local left_track = song:track(left_track_index)
                                local right_track = song:track(right_track_index)
                                
                                
                                --hide last remaining button if no devices are left in left-track
                                --[[
                                if #left_track.devices < 2 then
                                  vb.views["dev button"..i].visible = false
                                  return
                                end--]] --now in timer()
                                 
                                
                                --make sure all devices are matched up in both tracks
                                sync_track_devices(left_track_index,right_track_index)
                                
                                --make sure all presets are matched up
                                for i = 2,(#left_track.devices) do ---1) do
                                  local left_device = left_track:device(i)
                                  local right_device = right_track:device(i)
                                  --copy preset data
                                  right_device.active_preset_data = left_device.active_preset_data
                                  --copy enabled state
                                  right_device.is_active = left_device.is_active
                                  
                                  --make sure all parameters are not shown in mixer
                                 --[[ for i = 1, #left_device.parameters do
                                    right_device:parameter(i).show_in_mixer = false
                                    left_device:parameter(i).show_in_mixer = false
                                  end--]]
                                end
                                
                                  
                                --make sure left sc track is selected
                                song.selected_track_index = left_track_index
                                --select device in renoise
                                song.selected_track_device_index = linked_device_index
                                local sel_device = song.selected_track_device
                                
                                
                                
                                --copy enabled state
                                right_track:device(linked_device_index).is_active = left_track:device(linked_device_index).is_active
                                
                                ----------------------------------------------------------
                                local function close_all_but_selected_devices(device_index)
                                -----------------------------------------------------------
                                 --loop and close all device editors except passed index (left send)
                                 for i = 1, #song.selected_track.devices do
                                   if i ~= device_index then
                                   local device = song:track(song.selected_track_index):device(i)
                                     if (device.external_editor_available == true) then                    
                                       device.external_editor_visible = false
                                     end
                                   end
                                 end
                                 
                                 local send_track_right = song:track(song.selected_track_index+1)
                                 --loop and close all devices in send track right
                                 for i = 1, #send_track_right.devices do
                                   local device = send_track_right:device(i)
                                   if (device.external_editor_available == true) then                    
                                    -- device.external_editor_visible = false
                                   end
                                 end
                                end
                                ------------------------------------------------------
                                ------------------------------------------------------
                                close_all_but_selected_devices(linked_device_index)
                                
                                if (sel_device.external_editor_available == true) then
                                  sel_device.external_editor_visible = true
                                 -- vb.views["ext_ed"..i].color = COLOR_GREEN 
                                  vb.views["dev button"..button_number].color = COLOR_GREEN
                                  vb.views["minislider readout"].visible = true
                                else
                                --  vb.views["ext_ed"..i].color = COLOR_GREY 
                                  vb.views["dev button"..button_number].color = COLOR_GREY 
                                end
                                
                                if #left_track.devices > 1 then
                                  link_devices()
                                end
                                
                                --[[
                                if vb.views["dev button"..i].color[1] == COLOR_GREEN_FLAG then
                                  
                                  if (sel_device.external_editor_available == true) then
                                    sel_device.external_editor_visible = false
                                    vb.views["dev button"..i].color = COLOR_ORANGE
                                    return
                                  end
                                end
                                
                                --when button already orange
                                if vb.views["dev button"..i].color[1] == COLOR_GREY_FLAG then
                                  
                                  if (sel_device.external_editor_available == true) then
                                    sel_device.external_editor_visible = true
                                    vb.views["dev button"..i].color = COLOR_GREEN
                                 
                                  end
                                end 
                                --]]
                              end
  
                    },
                  
                  
                  --ext ed  
                  vb:text{
                    id = "ext_ed"..i,
                    width = 30,
                    height = 40,
                    text = " E",
                    visible = has_external_editor(i).available,
              
                    
                    }
           }
    --add each iteration into button_strip
     button_strip:add_child(button) 
        
  end--for loop
  
  
  local feedback_sliders = vb:column{
               margin = 4,
                vb:minislider{
                width = 150,
                height = 20,
                id = "minislider readout",
                visible = false, --hide in timer
                },
                
               vb:text{ --spacer
               
               }
               }
  
  
  
  
  local restart_tool_button = vb:row{
              margin = 4,
             -- vb:text{--spacer

              -- },
             
              vb:button{
               text = "Refresh Tool",
               height = 20,
               width = 80,
               notifier = function()
                            renoise.tool():remove_timer(timer)
                           -- status("timer_removed")
                            if my_dialog ~= nil then
                              my_dialog:close()
                              my_dialog = nil
                            end
                            --restart tool
                            main_gui()
                            return
                          end
              
              },
              
             vb:button{
              height =20,
              width = 70,
              text = "Routing",
              notifier = function()
                            ----------------------------------------
                            --toggle dialog
                            ----------------------------------------
                            if my_dialog2 and my_dialog2.visible then
                              --add timer to fire once every 50ms
                              my_dialog2:close()
                              my_dialog2 = nil 
                              return
                            end
                                        
              
              
                           local song = renoise.song()
                           vb2 = renoise.ViewBuilder()
                           my_dialog2 = vb2:text{}
                           
                           local track_button_strip2  = vb2:column {margin = 4}
                           for i = 1,song.sequencer_track_count do
                              button = vb2:row{ 
                                        vb2:textfield{
                                         text = song:track(i).name,
                                         width = 70,
                                         height = 30,
                                        -- font = "bold",
                                         bind = renoise.song():track(i).name_observable,
                                        },
                                        vb2:switch{
                                          items = {"Source","Effected","None"},
                                          width = 200,
                                          height = 30,
                                          value = get_tracks_state(i),
                                          
                                          notifier = function(value)
                                                     local song = renoise.song()
                                                     local track = song:track(i)
                                                     
                                                      
                                                     local send_indexes = get_sc_send_indexes()
                                                     if value == 1 then
                                                       local device = add_send_pointing_to_left_sc(i)
                                                       --change routing to modify to source send
                                                       device:parameter(2).value = 1
                                                       --change name
                                                       device.display_name = "Src to SC L"
                                                       --add pointing to right
                                                       device = add_send_pointing_to_right_sc(i)
                                                       --change routing to modify to source send
                                                       device:parameter(2).value = 0
                                                       --change name
                                                       device.display_name = "Src to SC R"
                                                       --add source sends
                                                     end

                                                    
                                                     if value == 2 then
                                                       add_send_pointing_to_left_sc(i)
                                                       add_send_pointing_to_right_sc(i)
                                                     end
                                                     
                                                     if value == 3 then
                                                       add_send_pointing_to_left_sc(i,true)
                                                       add_send_pointing_to_right_sc(i,true)
                                                     end
                                                     
                                                     
                                                     --[[
                                                     local routing = get_search_strings_for_send_device_routings()

                                                     for dev = 2,#track.devices do
                                                       local device = track:device(dev)
                                                       if device.device_path == "Audio/Effects/Native/#Send" then
                                                         
                                                         if string.find(device.active_preset_data, routing.left,1,true) ~= nil then
                                                           device.is_active = value
                                                         end
                                                         
                                                         if string.find(device.active_preset_data, routing.right,1,true) ~= nil then
                                                           device.is_active = value
                                                         end
                                                       
                                                       
                                                       end 
                                                         
                                                     end--]]
                                                     
                                                     end
                                        }
                                       }
                                       
                           
                            --add each iteration into button_strip
                            track_button_strip2:add_child(button) 
                           end
                           
                           
                           
                           
                           
                           
                           local dialog_content2 = vb2:row{}
                           dialog_content2:add_child(track_button_strip2)
                           
                             --------------
                              --key Handler
                              --------------
                              local function my_keyhandler_func(dialog,key)
                               --toggle lock focus hack, allows pattern ed to get key input
                                renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
                                renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
                                --return key 
                                return key
                              end 
                           

                             --Show dialog
                             my_dialog2 = renoise.app():show_custom_dialog(
                              "Routing", dialog_content2,my_keyhandler_func)
                            
                              --------------------------------------------    
                              --close dialog function ON NEW SONG
                              --------------------------------------------
                              local function closer(d)
                                my_dialog = nil    
                                if d and d.visible then
                                  d:close()
                                end
                                --remove timer
                                if renoise.tool():has_timer(timer) then
                                  renoise.tool():remove_timer(timer)
                                end
                              end
                              -- notifier to close dialog on load new song
                              --------------------------------------------
                              renoise.tool().app_release_document_observable:add_notifier(closer,my_dialog2)
                              -------------------------------------------------------------------------------
                            
                            
                         
                         end
                         
             
             },
              
            }
             
             
   
  
 

  


 
  local dialog_content = vb:column{}
  dialog_content:add_child(button_strip)
  dialog_content:add_child(feedback_sliders)
  dialog_content:add_child(restart_tool_button)
  
  
  --------------
  --key Handler
  --------------
  local function my_keyhandler_func(dialog,key)
   --toggle lock focus hack, allows pattern ed to get key input
    renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
    renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
    --return key 
    return key
  end 
  
  
  --Show dialog
  my_dialog = renoise.app():show_custom_dialog(
    "Fake A Sidechain", dialog_content,my_keyhandler_func)


  --------------------------------------------    
  --close dialog function ON NEW SONG
  --------------------------------------------
  local function closer(d)
    my_dialog = nil    
    if d and d.visible then
      d:close()
    end
    --remove timer
    if renoise.tool():has_timer(timer) then
      renoise.tool():remove_timer(timer)
    end
  end
  -- notifier to close dialog on load new song
  --------------------------------------------
  renoise.tool().app_release_document_observable:add_notifier(closer,my_dialog)
  -------------------------------------------------------------------------------
  
  --add timer to fire once every 50ms
  if not renoise.tool():has_timer(timer) then
    renoise.tool():add_timer(timer,80)
   -- status("timer_added")
  end
end--main_gui()
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------



--global varaible to store/ record the function attached to selected device notifier
local g_unlink_function = nil
--global variable to record the device passed into the link devices function
local g_link_parameters_dev = nil

--unlinks devices
------------------------------
function unlink_devices_on_selected_device_change(device)
----------------------------- 

  --hide minislider
  vb.views["minislider readout"].visible = false
  local song = renoise.song()
  
  --notifier 2)
  ----------------
  --remove selected device notifier
  if song.selected_device_observable:has_notifier(g_unlink_function) then
     song.selected_device_observable:remove_notifier(g_unlink_function)
  end
  
  --if device == nil then return, when device is deleted?
  if (device == nil) then --or (device.parameters == nil) then
    return
  end 
  
  --second check to see if device still exists
  if rawequal(device,g_link_parameters_dev) == false then
    return
  end
  
  --notifier 1)
  ----------------
  --check that the selected device in renoise is the same as the passed device
  --i.e. the device could have been removed
  if rawequal(device,renoise.song().selected_track_device) == false then
    --remove parameter notifiers
   -- print("")
   -- print(g_link_parameters_dev.name)
   -- print(device.name)--error
    for i = 1,#device.parameters do
      if device.parameters[i].value_observable:has_notifier(g_link_parameters_table[i]) then
        device.parameters[i].value_observable:remove_notifier(g_link_parameters_table[i])
      end
    end 
  end
end

--links devices (notifiers are all attched to the left_device)
-------------------------
function link_devices()
-------------------------
  
  --show the minislider to give user feedback when a parameter is
  --moved in the left device which also controls the same parameter in the right linked device
  vb.views["minislider readout"].visible = true
  
  local song = renoise.song()
  --get sc send indexes
  local left_track_index = get_sc_send_indexes().track[1]
  local right_track_index = get_sc_send_indexes().track[2]
  local left_track = song:track(left_track_index)
  local right_track = song:track(right_track_index)
  local left_device = left_track:device(song.selected_device_index)
  
  if song.selected_device == nil then
    status("No device Selected In Renoise")
    return
  end
  --return if mixer device selected
  if song.selected_device_index == 1 then
    status("No device Selected In Renoise")
    return
  end

  --[[local function round(num, numDecimalPlaces)
    local mult = 10^(numDecimalPlaces or 0)
    return math.floor(num * mult + 0.5) / mult
  end--]]

  --------------------------------
  local function link_parameters(parameter,device)
  --------------------------------
    
    --get objects
    local left_device = device
    local right_device = song:track(right_track_index):device(song.selected_device_index)
    local right_parameter = song:track(right_track_index):device(song.selected_device_index).parameters[parameter]
    local left_parameter = device.parameters[parameter]

    --mirror left parameters with the right hand ones
    right_parameter.value = left_parameter.value
    
    status("linked")
    --update minislider readout. As selected parameter changes, their ranges change so update that too 
    ------------------------------------
  
    --selected parameter range
    vb.views["minislider readout"].max = left_parameter.value_max
    vb.views["minislider readout"].min = left_parameter.value_min
  
    
    --if test, TO DEAL WITH BUG IN API?  meta devices returning routing values of -1 if routed to the current track--(been reported, may be fixed by API 6, post renoise 3.1)
    if (left_parameter.value < left_parameter.value_min) then
      vb.views["minislider readout"].value = left_parameter.value_min
    else 
      vb.views["minislider readout"].value = left_parameter.value
    end
   
    --update feedback slider in the tools gui
    vb.views["minislider readout"].visible = true
    vb.views["minislider readout"].value = left_parameter.value
    --vb.views["slider 2"].value = left_parameter.value
   
    --local right = round(right_parameter.value, 2)
    --local left = round(left_parameter.value, 2)
    --status("L//R Value = "..left.." <> "..right)

  end--local fn
  -------------------------------------------------
  -------------------------------------------------
  
  --add notifiers:
  
  --notifier 1)
  ----------------
  --loop  link_parameters(parameter,device) functions into global table
  for i = 1,(#left_device.parameters) do
    local device = song.selected_device
    g_link_parameters_table[i] = function() link_parameters(i,left_device) end
  end 
  
 
  --loop again to add notifiers to these table entries
  for i = 1,#left_device.parameters do
    if not left_device.parameters[i].value_observable:has_notifier(g_link_parameters_table[i]) then
      left_device.parameters[i].value_observable:add_notifier(g_link_parameters_table[i])
    end
  end
  
  g_link_parameters_dev = left_device
  
  --notifier 2)
  ----------------
  --assign unlink_devices..() function to global g_unlink_function
  g_unlink_function = function() unlink_devices_on_selected_device_change(left_device) end

  --notifier: Unlink devices when selected device changes in renoise
  if not song.selected_device_observable:has_notifier(g_unlink_function) then
    --add notifier
    song.selected_device_observable:add_notifier(g_unlink_function)
  end
end--link_devices()
-------------------
-------------------

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------
--------------------------------
function set_up_send_devices_all_tracks()
--------------------------------
--------------------------------

  sc_src = false
  sc_send_left = false
  sc_send_right = false
  local kick_track = nil

  local song = renoise.song()
  
  

  --loop to check for source track
  for track = 1, song.sequencer_track_count do
    if song:track(track).name == "SC Src" then
      sc_src = track
    end
  end
  
  --------------------------------------------------
  local function add_sc_send_tracks_if_not_present()
  --------------------------------------------------
    local song = renoise.song()
    --set global flags to false
    sc_send_left = false
    sc_send_right = false
    --loop to check for send SC tracks
    for track = (song.sequencer_track_count + 1), #song.tracks do
      if song:track(track).name == "SC Left" then
        sc_send_left = track
      elseif song:track(track).name == "SC Right" then
        sc_send_right = track
      end
    end
    
    --add left send track if not present
    ------------------------------------
    if (sc_send_left == false) then
      local insert_index = (song.sequencer_track_count + MASTER_TRACK + 1)
      song:insert_track_at(insert_index)
      song:track(insert_index).name = "SC Left"
      sc_send_left = insert_index
      --insert native compressor
      local compressor = song:track(insert_index):insert_device_at("Audio/Effects/Native/Compressor",2)
      compressor.active_preset_data =COMPRESSOR_ACTIVE_PRESET_DATA
    end
    
    --add right send track if not present
    --------------------------------------
    if (sc_send_right == false) then
      local insert_index = (sc_send_left + 1)
      song:insert_track_at(insert_index)
      song:track(insert_index).name = "SC Right"
      sc_send_right = insert_index
      --insert native compressor
      local compressor = song:track(insert_index):insert_device_at("Audio/Effects/Native/Compressor",2)
      compressor.active_preset_data =COMPRESSOR_ACTIVE_PRESET_DATA
    end
  end--end local fn
  add_sc_send_tracks_if_not_present()
  
  
  --add source track if not present
  --------------------------------------
  if (sc_src == false) then
    local index = 1
    song:insert_track_at(index)
    song:track(index).name = "SC Src"
    
    --add Sc Src send device pointing to left sc send track
    -------------------------------------------------------
    local send_indexes = get_sc_send_indexes()
    --add a send device, muted and pointing at correct send track
    local target_to_string = tostring(send_indexes.send_no[1] - LUA_COUNTS_FROM_1)
    local send_device = song:track(index):insert_device_at("Audio/Effects/Native/#Send",2)
     send_device.active_preset_data =
                                
           [[<?xml version="1.0" encoding="UTF-8"?>
        <FilterDevicePreset doc_version="9">
          <DeviceSlot type="SendDevice">
            <IsMaximized>true</IsMaximized>
            <SendAmount>
              <Value>1.0</Value>
            </SendAmount>
            <SendPan>
              <Value>1.0</Value>
            </SendPan>
            <DestSendTrack>
              <Value>]]..target_to_string..[[</Value>
            </DestSendTrack>
            <MuteSource>false</MuteSource>
            <SmoothParameterChanges>true</SmoothParameterChanges>
          </DeviceSlot>
        </FilterDevicePreset>
        ]]
        send_device:parameter(1).show_in_mixer = false
        send_device.display_name = "Src to SC L"
        
    --add Sc Src send device pointing to ruight sc send track
    local target_to_string_1 = tostring(send_indexes.send_no[2]- LUA_COUNTS_FROM_1)
    local send_device = song:track(index):insert_device_at("Audio/Effects/Native/#Send",3)
     send_device.active_preset_data =
                                
           [[<?xml version="1.0" encoding="UTF-8"?>
        <FilterDevicePreset doc_version="9">
          <DeviceSlot type="SendDevice">
            <IsMaximized>true</IsMaximized>
            <SendAmount>
              <Value>1.0</Value>
            </SendAmount>
            <SendPan>
              <Value>0</Value>
            </SendPan>
            <DestSendTrack>
              <Value>]]..target_to_string_1..[[</Value>
            </DestSendTrack>
            <MuteSource>true</MuteSource>
            <SmoothParameterChanges>true</SmoothParameterChanges>
          </DeviceSlot>
        </FilterDevicePreset>
        ]]  
        send_device:parameter(1).show_in_mixer = false
        send_device.display_name = "Src to SC R"    
    --record where left source track is
    sc_src = index + 1
   
  
   --If called by menu entry then set up source track with 4X4 kick
   if menu_call == true then
     local lpb = song.transport.lpb
     local inst = song.selected_instrument_index - LUA_COUNTS_FROM_1
     for i = 1,#song.patterns do
       local pattern = song:pattern(i)
       for j = 1,pattern.number_of_lines do
         if ((j-1) % lpb == 0) then --every `lpb` lines (4 is default in renoise)
           song:pattern(i):track(1):line(j):note_column(1).note_string = "C-4"
           song:pattern(i):track(1):line(j):note_column(1).instrument_value = inst
         end       
       end
     end
     
     --now set up kick track
     kick_track = song:insert_track_at(2)
     kick_track.name = "Kick"
     renoise.song().instruments[2]:copy_from(song.selected_instrument)
      for i = 1,#song.patterns do
        local pattern = song:pattern(i)
        for j = 1,pattern.number_of_lines do
          if ((j-1) % lpb == 0) then --every `lpb` lines (4 is default in renoise)
            song:pattern(i):track(2):line(j):note_column(1).note_string = "C-4"
            song:pattern(i):track(2):line(j):note_column(1).instrument_value = inst + 1
          end       
        end
        kick_track = 2--flag for later
      end
    end   
  end
  

  
  
  
  local send_indexes = get_sc_send_indexes()
  local left_send_track = song:track(send_indexes.track[1])
  local right_send_track = song:track(send_indexes.track[2])
  --set panning for right and left tracks
  left_send_track.postfx_panning.value = 0
  right_send_track.postfx_panning.value = 1

  local send_pointing_to_none_string =   
    [[<DestSendTrack>
      <Value>-1</Value>
    </DestSendTrack>]]

  local send_pointing_to_left_string =
    [[<DestSendTrack>
      <Value>]]..send_indexes.send_no[1]..".0"..[[</Value>
    </DestSendTrack>]]

  local send_pointing_to_right_string =
    [[<DestSendTrack>
      <Value>]]..send_indexes.send_no[2]..".0"..[[</Value>
    </DestSendTrack>]] 
  
  
  
  --loop all tracks
  ----------------------------------------
  --add send devices to all sequeencer tracks
  ----------------------------------------
   --delete send devices with no active send
    for track = 1, song.sequencer_track_count do
      for device = #song:track(track).devices,2,-1 do --count backwards as deleting devices changes indexes
        if song:track(track):device(device).device_path == "Audio/Effects/Native/#Send" then 
          if string.find(song:track(track):device(device).active_preset_data, send_pointing_to_none_string,1,true) ~= nil then
            song:track(track):delete_device_at(device)  
          end
        end 
      end
    end
       
     --add send  (left SC)
     -----------------------------------------
     for track = 1, song.sequencer_track_count do
       if track ~= kick_track then--kick track flag == 2
       local send_to_left_found = false
       for device = #song:track(track).devices,2,-1 do
         if song:track(track):device(device).device_path == "Audio/Effects/Native/#Send" then
           if string.find(song:track(track):device(device).active_preset_data, send_pointing_to_left_string,1,true) ~= nil then
             send_to_left_found = true
             break
           end
         end
       end
       if send_to_left_found == false then
       --add send
       
      local target_to_string = tostring(send_indexes.send_no[1] - LUA_COUNTS_FROM_1)
      local send_device = song:track(track):insert_device_at("Audio/Effects/Native/#Send",#song:track(track).devices + 1)
       send_device.active_preset_data =
                                  
             [[<?xml version="1.0" encoding="UTF-8"?>
          <FilterDevicePreset doc_version="9">
            <DeviceSlot type="SendDevice">
              <IsMaximized>true</IsMaximized>
              <SendAmount>
                <Value>1.0</Value>
              </SendAmount>
              <SendPan>
                <Value>0</Value>
              </SendPan>
              <DestSendTrack>
                <Value>]]..target_to_string..[[</Value>
              </DestSendTrack>
              <MuteSource>false</MuteSource>
              <SmoothParameterChanges>true</SmoothParameterChanges>
            </DeviceSlot>
          </FilterDevicePreset>
          ]]
       
       send_device:parameter(1).show_in_mixer = false
       send_device.display_name = "To SC Left"
     end
   end
  end
  
  
     --add send (right SC)
   -----------------------------------------
   for track = 1, song.sequencer_track_count do
     local send_to_left_found = false
     if track ~= kick_track then--kick track flag == 2
     for device = #song:track(track).devices,2,-1 do
       if song:track(track):device(device).device_path == "Audio/Effects/Native/#Send" then
         if string.find(song:track(track):device(device).active_preset_data, send_pointing_to_left_string,1,true) ~= nil then
           send_to_left_found = true
           break
         end
       end
     end
     if send_to_left_found == false then
       --add send
     
       local target_to_string = tostring(send_indexes.send_no[2] - LUA_COUNTS_FROM_1)
       local send_device = song:track(track):insert_device_at("Audio/Effects/Native/#Send",#song:track(track).devices + 1)
     send_device.active_preset_data =
                                
           [[<?xml version="1.0" encoding="UTF-8"?>
        <FilterDevicePreset doc_version="9">
          <DeviceSlot type="SendDevice">
            <IsMaximized>true</IsMaximized>
            <SendAmount>
              <Value>1.0</Value>
            </SendAmount>
            <SendPan>
              <Value>1.0</Value>
            </SendPan>
            <DestSendTrack>
              <Value>]]..target_to_string..[[</Value>
            </DestSendTrack>
            <MuteSource>true</MuteSource>
            <SmoothParameterChanges>true</SmoothParameterChanges>
          </DeviceSlot>
        </FilterDevicePreset>
        ]]
     send_device:parameter(1).show_in_mixer = false
     send_device.display_name = "To SC Right"
   end
  end
 end  
end









